#guard Mokladr_Lib

/*

=============================================
= Библиотеку создал: Nokladr                =
= Дата:              18.02.2016             =
= Skype:             stepa446               =
= E-Mail:            Nostaleal.ru@yandex.ru =
=============================================

*/

library MokladrLib
	include "cj_order.j"
	include "cj_print.j"
	include "cj_types.j"
	include "cj_typesEx.j"
	include "cj_types_priv.j"
	include "cj_typesEx_priv.j"

    globals
        constant string GOLD =      "|cffffcc00"    // gold
        constant string RED =       "|cffff0000"    // 0
        constant string BLUE =      "|cff0000ff"    // 1
        constant string TEAL =      "|cff00f5ff"    // 2
        constant string PURPLE =    "|cff551A8B"    // 3
        constant string YELLOW =    "|cffffff00"    // 4
        constant string ORANGE =    "|cffEE9A00"    // 5
        constant string GREEN =     "|cff00CD00"    // 6
        constant string PINK =      "|cffFF69B4"    // 7
        constant string GRAY =      "|cffC0C0C0"    // 8
        constant string LB =        "|cffB0E2FF"    // 9
        constant string DG =        "|cff006400"    // 10
        constant string BROWN =     "|cff8B4513"    // 11
        int time[3] //0:time - секунды, 1:time - минуты, 2:time - часы
        player C_IsUnitCollapseWithEnemiesPlayer
    endglobals

    define {
        //#define


    }

    void C_ErrorMsg(string s)
    {
        printf(RED + "Ошибка: " + s + "|r")
    }

    // Компьютер
    void C_SetComputers()
    {
        int i = 0
        while (i < 15)
        {
            if (GetPlayerController(Player(i)) == MAP_CONTROL_COMPUTER)
            {
                SetPlayerName(Player(i), "Компьютер")
                SetPlayerOnScoreScreen(Player(i), false)
            }
            i++
        } 
    }

    void C_ResizeTable(leaderboard l)
    {
        int size = LeaderboardGetItemCount(l)
        if (LeaderboardGetLabelText(l) == "")
        {
            size--
        }
        LeaderboardSetSizeByItemCount(l, size)
    }

    void C_RemoveTableRow(leaderboard l, int row)
    {
        LeaderboardRemoveItem(l, row)
        C_ResizeTable(l)
    }

    void C_AddTableRow(leaderboard l, string label, int value, bool flag)
    {
        int i = 0
        bool complete = false
        while (i < 15)
        {
            if (!LeaderboardHasPlayerItem(l, Player(i)))
            {
                LeaderboardAddItem(l, label, value, Player(i))
                if (label == "" && value == 0)
                {
                    LeaderboardSetItemStyle(l, i, false, false, false)
                }
                elseif (value == 0 && !flag)
                {
                    LeaderboardSetItemStyle(l, i, true, false, false)
                }
                complete = true
            }
            if (complete)
            {
                C_ResizeTable(l)
                break
            }
            i++
        }
        if (!complete)
        {
            C_ErrorMsg("невозможно создать строку в таблице. Освободите место.")
        }
    }

    private void C_StartCount()
    {
        0:time++
        if (0:time > 59)
        {
            0:time = 0
            1:time++
            if (1:time > 59)
            {
                1:time = 0
                2:time++
                if (2:time > 24)
                {
                    0:time = 0 //Секунды
                    1:time = 0 //Минуты
                    2:time = 0 //Часы
                }
            }
        }
    }

    void C_StartInitTimer()
    {
        timer t = new timer
        TimerStart(t, 1., true, function C_StartCount)
    }

    //Таблица
    leaderboard C_CreateTable(string label, bool IsVisible)
    {
        leaderboard l = new leaderboard
        int i = 0
        while(i < 15)
        {
            PlayerSetLeaderboard(Player(i), l)
            i++
        }
        LeaderboardSetLabel(l, label)
        LeaderboardDisplay(l, IsVisible)
        return l
    }

    void C_AddGoldToPlayer(int value, player p)
    {
        //Добавляет золото игроку
        SetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD, GetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD) + value)
    }

    void C_RemoveGoldFromPlayer(int value, player p)
    {
        //Забирает золото у игрока
        SetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD, GetPlayerState(p, PLAYER_STATE_RESOURCE_GOLD) - value)
    }

    void C_AddLumberToPlayer(int value, player p)
    {
        //Добавляет дерево игроку
        SetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER, GetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER) + value)
    }

    void C_RemoveLumberFromPlayer(int value, player p)
    {
        //Забирает дерево у игрока
        SetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER, GetPlayerState(p, PLAYER_STATE_RESOURCE_LUMBER) - value)
    }

    location C_RectToLoc(rect r)
    {
        location l = Location(GetRectCenterX(r), GetRectCenterY(r))
        return l
    }

    bool C_UnitHasItemOfType(unit u, int itemId)
    {
        int i = 0
        item indexItem
        while (i < 6)
        {
            indexItem = UnitItemInSlot(u,i)
            if (indexItem != null && GetItemTypeId(indexItem) == itemId)
            {
                return true
            }
            i++
        }
        return false
    }

    bool C_IsUnitInRect(unit u, rect r)
    {
        float x = GetUnitX(u)
        float y = GetUnitY(u)
        if (GetRectMinX(r)-32 <= x) && (x <= GetRectMaxX(r)+32) && (GetRectMinY(r)-32 <= y) && (y <= GetRectMaxY(r)+32)
        {
            return true
        }
        return false
    }

    bool C_IsUnitCollapse(unit u, real radius)
    {
    	float x = GetUnitX(u)
    	float y = GetUnitY(u)
    	group g = new group
    	bj_groupCountUnits = 0
    	GroupEnumUnitsInRange(g, x, y, radius, null)
    	ForGroup(g, function CountUnitsInGroupEnum)
    	int count = bj_groupCountUnits
        DestroyGroup(g)
        if (count == 1)
        {
        	return false
        }
        return true
    }

    bool CountUnitsInGroupEnumWithNoAllies()
    {
        unit u = GetFilterUnit()
        if (!IsPlayerAlly(GetOwningPlayer(u), C_IsUnitCollapseWithEnemiesPlayer) && GetUnitState(u, UNIT_STATE_LIFE) > 0) then
            return true
        endif
        return false
    }

    bool CountUnitsInGroupEnumWithAllies()
    {
        unit u = GetFilterUnit()
        if (GetOwningPlayer(u) == C_IsUnitCollapseWithEnemiesPlayer || IsPlayerAlly(GetOwningPlayer(u), C_IsUnitCollapseWithEnemiesPlayer)) then
            if (GetUnitState(u, UNIT_STATE_LIFE) > 0) then
                return true
            endif
        endif
        return false
    }

    bool C_IsUnitCollapseWithEnemies(unit u, real radius)
    {
        float x = GetUnitX(u)
        float y = GetUnitY(u)
        group g = new group
        bj_groupCountUnits = 0
        C_IsUnitCollapseWithEnemiesPlayer = GetOwningPlayer(u)
        GroupEnumUnitsInRange(g, x, y, radius, Condition(function CountUnitsInGroupEnumWithNoAllies))
        ForGroup(g, function CountUnitsInGroupEnum)
        int count = bj_groupCountUnits
        DestroyGroup(g)
        if (count == 0)
        {
            return false
        }
        return true
    }
endlibrary